# -*- coding: utf-8 -*-
"""
@author: Eleve
"""
import matplotlib.pyplot as plt
import math
import time
import random
import numpy as np

# DEBUT :Extraction des données issues des mesures
fichier='D:/Cours/lycee/infoprepa/filtrage/results.csv'
f=open(fichier,mode='r')  # ouverture du fichier en mode lecture
L_temps=[]                # initialisation de la liste des temps
L_omega=[]                # initialisation de la liste des mesures

for ligne in f:

        ligne=ligne.replace(',','.')
        s=ligne.split(';')
        for i in range(2): s[i]=float(s[i]) # à expliquer
        L_temps.append(s[0])
        L_omega.append(s[1]*math.pi/180)  #;a modifier pour avoir des radians par seconde

f.close() # fermeture du fichier
# FIN Extraction des données issues des mesures


plt.plot(L_temps,L_omega)
plt.axhline(color='black') #affichage de l'axe des x
plt.axvline(color='black') #affichage de l'axe des y
plt.show()



#-------- ACTIVITE 8  -------#
def omega_anal(t,tau):
    K=14.9  # à modifier
    Uo=10
    return K*Uo*(1-np.exp(-t/(tau)))



#-------- ACTIVITE 9  -------#
def Erreur(tau,L_temps,L_omega):
    err=0
    # à compléter
    n=len(L_temps)
    for i in range(n):
        err += (omega_anal(L_temps[i],tau)-L_omega[i])**2
    return err

L_tau=np.arange(0.01,1,0.01)
L_err=Erreur(L_tau,L_temps,L_omega)
plt.plot(L_tau,L_err)
plt.axhline(color='black') #affichage de l'axe des x
plt.axvline(color='black') #affichage de l'axe des y
plt.show()


def Erreur_der(tau,L_temps,L_exp): # ne pas modifier cette fonction
    dtau=0.0001
    derr=Erreur(tau+dtau,L_temps,L_exp)-Erreur(tau-dtau,L_temps,L_exp)
    return derr/(2*dtau)


def Erreur_der2(tau,L_temps,L_exp):# ne pas modifier cette fonction
    dtau=0.0001
    derr=Erreur_der(tau+dtau,L_temps,L_exp)-Erreur_der(tau-dtau,L_temps,L_exp)
    return derr/(2*dtau)

#-------- ACTIVITE 10  -------#
def minimum(L_temps,L_omega):
    a=0.01
    b=1
    while b-a>0.0001:
        m=(b+a)/2
        fa=Erreur_der(a,L_temps,L_omega)
        fm=Erreur_der(m,L_temps,L_omega)
        if fm*fa <0:
            b=m
        else:
            a=m
    return (a+b)/2
